/********************************************************************************
|  CLASS:         TLS2118 - Getting Started with MPLAB C for PIC18
|  PROGRAM:       Lab1.c   
|  AUTHOR:        Rob Ostapiuk
|  DATE:          30 APR 2009
|  DESCRIPTION:   First MPLAB C18 project to test whether everything is working
|  REQUIREMENTS:  TLS2118.lib 
|                 Jumper J6 (next to LEDs) must be REMOVED                
| 
|  REVISION HISTORY:
|  30 APR 2009    Rob Ostapiuk v1.0
 ********************************************************************************/
#include <p18cxxx.h>
#include "P18F_LCD.h"

#pragma config OSC=INTIO7, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

#define	LED1	LATDbits.LATD0
#define	LED8	LATDbits.LATD7

void
SW_Delay (void)
{
  unsigned Delay_X;
  for (Delay_X = 0; Delay_X < 20000; Delay_X++)
    {
      Nop ();
    }
}

void
main (void)
{
  OSCCONbits.IRCF = 0x07; // ToDo : 可以調整 IRCF 位元來設定工作頻率
  // Select INTOSC-8Mhz as clock source
  // 此位元結構成員名稱是用於 C18 v3.37 (含)版本以後
  Nop (); // 如使用 v.3.36 以前版本請參考 p18f4520.h 檔裡的名稱定義
  OpenLCD ();

  //Type casting required because library is built with large code model but
  //MPLAB defaults to small code model
  LCD_Set_Cursor (0, 0);
  putrsLCD ((const far char*) "  X IDE Lab 2   ");

  LCD_Set_Cursor (1, 0);

#ifdef Expensive_Version    // 建立條件式編譯劇本一 (Expensive Version)
  putrsLCD ((const far char*) "I am Expensive..");
#endif

#ifdef Cheap_Version         // 建立條件式編譯劇本二 (Chep Version)
  putrsLCD ((const far char*) "I am Cheap......");
#endif

  LATD = 0x00; // Turn Off all LEDs

  while (1)
    {
      SW_Delay ();
#ifdef Expensive_Version    // 建立條件式編譯劇本一 (Expensive Version)
      LED1 = !LED1;
#endif

#ifdef Cheap_Version         // 建立條件式編譯劇本二 (Chep Version)
      LED8 = !LED8;
#endif
    }
}
