/********************************************************************************
|  CLASS:         TLS2118 - Getting Started with MPLAB C for PIC18
|  PROGRAM:       Lab3.c   
|  DESCRIPTION:   First MPLAB C18 project to test whether everything is working
|  REQUIREMENTS:  TLS2118.lib 
|                              
| 
|  REVISION HISTORY:
|  30 APR 2009    Rob Ostapiuk v1.0
********************************************************************************/
#include <p18cxxx.h>
#include "P18F_LCD.h"
#include <stdlib.h>
#include <timers.h>

#define	LED1	LATDbits.LATD0
#define	SW2	PORTBbits.RB0
#define	TIMER1_INT_FLAG		PIR1bits.TMR1IF
#define	TIMER1_1ms_VALUE 	65536-(1000*2)+156 		//	CPU runs @ 8Mhz , 2MHZ Fcy , 1ms = 1000 us

unsigned char	HH = 0 ;
unsigned char	MM = 0 ; 
unsigned char	SE = 0 ;
unsigned int	Timer1_Acc = 0 ;
unsigned char	FLAG_1ms ;

char	ASCII_Buffer[10] ;
void	Update_Time(void) ;
void	Update_LCD(void) ;
void	putDecLCD(unsigned char) ;


void interrupt HighISR(void)
{
	if (TIMER1_INT_FLAG)
	{
		TIMER1_INT_FLAG = 0 ;
		WriteTimer1(TIMER1_1ms_VALUE);
		FLAG_1ms = 1 ;
	}
}
 

void main(void)
{
	OSCCONbits.IRCF = 0x07 ;		// 	Select INTOSC-8Mhz as clock source
						// 	ToDo : 可以調整 IRCF 位元來設定工作頻率 
	ADCON1bits.PCFG = 0x0f ;		//	Set all ADC multiplexed pins as digital mode
    OpenLCD();

    putrsLCD((const far char*)"Lab3 Int/Timer1 ");
	LCD_Set_Cursor(1,0) ;
	putrsLCD((const far char*)"Time= HH:MM:SS");

	INTCONbits.GIE = 1 ;
	INTCONbits.PEIE = 1 ;

	LATD = 0x00 ;		// Turn Off all LEDs

		WriteTimer1(TIMER1_1ms_VALUE);
		OpenTimer1(	TIMER_INT_ON & T1_16BIT_RW &\
					T1_SOURCE_INT & T1_PS_1_1 & \
					T1_OSC1EN_OFF & T1_SYNC_EXT_OFF ) ;
		
    
    while(1)
	{
		if (FLAG_1ms)
		{
			FLAG_1ms = 0 ;
			Timer1_Acc ++ ;
			if ( Timer1_Acc == 1000 )  // = 1 秒，更新 LCD 的時間顯示
			{
				Timer1_Acc = 0 ;
				Update_Time() ;
				Update_LCD() ;
			}
		}

	}	
}

void	Update_Time(void)
{
		SE ++ ;
		if ( SE == 60 )
		{
			SE = 0 ;
			MM ++ ;
			if ( MM == 60 )
			{
				MM = 0 ;
				HH ++ ;
				if ( HH == 12 )
				{	HH = 0 ;	}
			}
		}
}

void Update_LCD(void)
{
	LCD_Set_Cursor(1,6);
	putDecLCD(HH);
	LCD_Set_Cursor(1,9);
	putDecLCD(MM);
	LCD_Set_Cursor(1,12);
	putDecLCD(SE);
}

void putDecLCD(unsigned char Dec_Value)
{
	unsigned char	Temp_Dec ;
	Temp_Dec = (Dec_Value/10) + '0' ;
	putcLCD(Temp_Dec) ;
	Temp_Dec = (Dec_Value%10) + '0' ;
	putcLCD(Temp_Dec) ;
}